/*
 * $Id: 
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <string.h>
#include <ctype.h>

#include <exec/execbase.h>

#define DEBUG 0
#include <aros/debug.h>

#define	LOGINCMD	 "login -f "
#define	LOGINCMD_GUI "login -g"

void LoadUserPrefs(char *filename)
{
	D(bug("IPrefs: UserPrefs <%s>\n",filename));

	if (CheckForNetstack())
	{
		BPTR MyFile;

		#if 0
		#warning "Test mode"
		if (SysBase->ex_DebugFlags & EXECDEBUGF_INITRESIDENT)
		{
			D(bug("IPrefs: file not found\n"));
			D(bug("IPrefs: gui login\n"));
			if (SystemTags(LOGINCMD_GUI,
			               SYS_Asynch, FALSE,
			               TAG_END) != -1)
			{
				D(bug("IPrefs: system login done\n"));
			}
			else
			{
				D(bug("IPrefs: system error %ld\n",IoErr()));
			}
		}
		#endif

		if ((MyFile = Open(filename,MODE_OLDFILE)))
		{
			UBYTE _fib[sizeof(struct FileInfoBlock) + 3];
			struct FileInfoBlock *fib = (APTR) ((((IPTR) _fib) + 3) & ~3);
			LONG FileSize;

			if (ExamineFH(MyFile, fib) && (FileSize = fib->fib_Size) > 0)
			{
				UBYTE	*MyData;

				if (FileSize < 0x7fffff00 && (MyData = AllocVec(FileSize + sizeof(LOGINCMD) + 1, MEMF_PUBLIC)))
				{
					UBYTE *login = MyData + sizeof(LOGINCMD) - 1;

					memcpy(MyData, LOGINCMD, sizeof(LOGINCMD) - 1);
					if (FGets(MyFile,
					          login,
					          FileSize + 1))
					{
						BPTR ifh, ofh;
						int len, i;

						len = strlen(login);
						if (len && login[len - 1] == '\n')
						{
							login[len - 1] = '\0';
							len--;
						}
						for (i = 0; i < len; i++)
						{
							if (login[i] == '`' ||
							    login[i] < ' ' ||
							    login[i] == 0x9b)
							{
								login[i] = ' ';
							}
						}

						D(bug("IPrefs: <%s>\n",MyData));

						ifh = Open("NIL:", MODE_OLDFILE);
						ofh = Open("NIL:", MODE_NEWFILE);
						if (ifh && ofh)
						{
							if (SystemTags(MyData,
							               SYS_Asynch, TRUE,
							               SYS_Input,  ifh,
							               SYS_Output, ofh,
							               TAG_END) != -1)
							{
								ifh = 0;
								ofh = 0;
							}
							else
							{
								D(bug("IPrefs: system error %ld\n",IoErr()));
							}
						}
						else
						{
							D(bug("IPrefs: nil: open error %ld\n",IoErr()));
						}

						if (ofh)
						{
							Close(ofh);
						}

						if (ifh)
						{
							Close(ifh);
						}
					}
					else
					{
						D(bug("IPrefs: readerror %ld\n",IoErr()));
					}

					FreeVec(MyData);
				}
				else
				{
					D(bug("IPrefs: no enough memory for %ld bytes\n",FileSize));
				}
			}
			else
			{
				D(bug("IPrefs: examine error or no file content\n"));
			}

			Close(MyFile);
		}
		else
		{
			D(bug("IPrefs: file not found\n"));
			D(bug("IPrefs: gui login\n"));

			if (SystemTags(LOGINCMD_GUI,
			               SYS_Asynch, FALSE,
			               TAG_END) != -1)
			{
				D(bug("IPrefs: system login done\n"));
			}
			else
			{
				D(bug("IPrefs: system error %ld\n",IoErr()));
			}
		}
	}
	else
	{
		D(bug("IPrefs: NetStack disabled\n"));
	}
}
